Remove CONFIG_{QEMU,VMWARE} its handled in grml-x nowadays.
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 ################################################################################
8
9 # {{{ path, variables, signals, umask, zsh
10 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
11 DEBUG="/dev/null"
12 KERNEL="$(uname -r)"
13 ARCH="$(uname -m)"
14 umask 022
15
16 # old linuxrc version:
17 [ -d /cdrom ]      && export LIVECD_PATH=/cdrom
18 # new initramfs layout:
19 [ -d /live/image ] && export LIVECD_PATH=/live/image
20
21 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
22 [ -z "$PS1" ] && trap "" 2 3 11
23
24 # zsh stuff
25 iszsh(){
26 if [ -n "$ZSH_VERSION" ] ; then
27   return 0
28 else
29   return 1
30 fi
31 }
32 # avoid 'no matches found: ...'
33 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
34 # }}}
35
36 # {{{ Read in boot parameters
37 if [ -z "$CMDLINE" ]; then
38   # if CMDLINE was set from the outside, we're debugging.
39   # otherwise, take CMDLINE from Kernel and config files.
40   CMDLINE="$(cat /proc/cmdline)"
41   [ -d /cdrom/bootparams/ ]      && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
42   [ -d /live/image/bootparams/ ] && CMDLINE="$CMDLINE $(cat /live/image/bootparams/* | tr '\n' ' ')"
43 fi
44 # }}}
45
46 ### {{{ Utility Functions
47
48 # Get a bootoption's parameter: read boot command line and either
49 # echo last parameter's argument or return false.
50 getbootparam(){
51   local line
52   local ws
53   ws='   '
54   line=" $CMDLINE "
55   case "$line" in
56     *[${ws}]"$1="*)
57       result="${line##*[$ws]$1=}"
58       result="${result%%[$ws]*}"
59       echo "$result"
60       return 0 ;;
61     *) # no match?
62       return 1 ;;
63   esac
64 }
65
66 # Check boot commandline for specified option
67 checkbootparam(){
68   [ -n "$1" ] || ( echo "Error: missing argument to checkbootparam()" ; return 1 )
69   local line
70   local ws
71   ws='   '
72   line=" $CMDLINE "
73   case "$line" in
74     *[${ws}]"$1"=*|*[${ws}]"$1"[${ws}]*)
75       return 0 ;;
76     *)
77       return 1 ;;
78   esac
79 }
80
81 # Check if currently using a framebuffer
82 hasfb() {
83     [ -e /dev/fb0 ] && return 0 || return 1
84 }
85
86 # Check wheter a configuration variable (like $CONFIG_TOHD) is
87 # enabled or not
88 checkvalue(){
89   case "$1" in
90     [yY][eE][sS])     return 0 ;; # it's set to 'yes'
91     [tT][rR][uU][eE]) return 0 ;; # it's set to 'true'
92                    *) return 1 ;; # default
93   esac
94 }
95
96 # Are we using grml-small?
97 checkgrmlsmall(){
98   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
99 }
100
101 # execute flite only if it's present
102 flitewrapper() {
103    [ -x /usr/bin/flite ] && flite -o play -t "$*"
104 }
105 ### }}}
106
107 # {{{ filesystems (proc, pts, sys) and fixes
108 mount_proc(){
109   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
110 }
111
112 mount_pts(){
113   grep -q "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
114 }
115
116 mount_sys(){
117   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
118 }
119 # }}}
120
121 # {{{ Check if we are running in live mode or from HD
122 INSTALLED=""
123 [ -e /etc/grml_cd ] || INSTALLED="yes"
124
125 # testcd
126 TESTCD=""
127 checkbootparam 'testcd' >>$DEBUG 2>&1 && TESTCD="yes"
128 # }}}
129
130 # {{{ source lsb-functions , color handling
131 if checkbootparam 'nocolor'; then
132   RC_NOCOLOR=yes
133   . /etc/grml/lsb-functions
134   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
135 else
136   . /etc/grml/lsb-functions
137   . /etc/grml_colors
138 fi
139 # }}}
140
141 # {{{ debug
142 config_debug(){
143  checkbootparam 'debug'            && BOOTDEBUG="yes"
144  checkbootparam "BOOT_IMAGE=debug" && BOOTDEBUG="yes"
145
146  rundebugshell(){
147   if [ -n "$BOOTDEBUG" ]; then
148      einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
149      if [ grep -q "debug=noscreen" "$CMDLINE" ] ; then
150         einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
151         einfo "Just exit the shell to continue boot process..."
152         /bin/zsh
153      else
154         eindent
155         if [ -r /etc/grml/screenrc ] ; then
156            einfo "Starting GNU screen to be able to use a full featured shell environment."
157            einfo "Just exit the shells (and therefore screen) to continue boot process..."
158            /bin/zsh -c "screen -c /etc/grml/screenrc"
159         else
160            einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
161            einfo "Just exit the shell to continue boot process..."
162            /bin/zsh
163         fi
164         eoutdent
165      fi
166   fi
167  }
168 }
169 # }}}
170
171 # {{{ log
172 config_log(){
173 if checkbootparam 'log' || checkbootparam 'debug' ; then
174    export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
175    touch $DEBUG
176    einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot"
177    eindent
178      einfo "Starting bootlogd." # known to be *very* unreliable :(
179      bootlogd -r -c >>$DEBUG 2>&1 ; eend $?
180    eoutdent
181 else
182    DEBUG="/dev/null"
183 fi
184 }
185 # }}}
186
187 # {{{ set firmware timeout via bootparam
188 config_fwtimeout(){
189  if checkbootparam 'fwtimeout' ; then
190    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
191    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
192    rmmod firmware_class >>$DEBUG 2>&1
193    modprobe firmware_class ; eend $?
194  fi
195  if [ -z "$TIMEOUT" ] ; then
196    TIMEOUT="100" # linux kernel default: 10
197  fi
198  if [ -f /sys/class/firmware/timeout ] ; then
199    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
200    echo 100 > /sys/class/firmware/timeout ; eend $?
201  fi
202 }
203 # }}}
204
205 ### {{{ language configuration / localization
206 config_language(){
207
208  einfo "Activating language settings:"
209  eindent
210
211  # people can specify $LANGUAGE and $CONSOLEFONT in a config file
212  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
213
214  # check for bootoption which overrides config from /etc/grml/autoconfig
215  BOOT_LANGUAGE="$(getbootparam 'lang' 2>>$DEBUG)"
216  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
217
218  # set default to 'en' in live-cd mode iff $LANGUAGE is not set yet
219  if [ -z "$INSTALLED" ] ; then
220     [ -n "$LANGUAGE" ] || LANGUAGE='en'
221  fi
222
223  if [ -x /usr/sbin/grml-setlang ] ; then
224    # if bootoption lang is used update /etc/default/locale accordingly
225    if [ -n "$BOOT_LANGUAGE" ] ; then
226      checkgrmlsmall && /usr/sbin/grml-setlang "POSIX" || /usr/sbin/grml-setlang "$LANGUAGE"
227    # otherwise default to lang=en
228    else
229      checkgrmlsmall && /usr/sbin/grml-setlang "POSIX" || /usr/sbin/grml-setlang "en"
230    fi
231  fi
232
233  # set console font
234  if [ -z "$CONSOLEFONT" ] ; then
235     if ! checkbootparam 'nodefaultfont' >>$DEBUG 2>&1 ; then
236        if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
237           CONSOLEFONT='Uni3-Terminus16'
238        else
239           ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
240        fi
241        if ! hasfb ; then
242           CONSOLEFONT='Lat15-Terminus16'
243        fi
244     fi
245  fi
246
247  # export it now, so error messages get translated, too
248  if checkgrmlsmall ; then
249     export LANG='C' # grml-small does not provide any further locales
250  else
251     [ -r /etc/default/locale ] && . /etc/default/locale
252     export LANG LANGUAGE
253  fi
254
255  # configure keyboard layout, read in already set values first:
256  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
257
258  # now allow keyboard override by boot commandline for later use:
259  KKEYBOARD="$(getbootparam 'keyboard' 2>>$DEBUG)"
260  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
261  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
262  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
263  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
264
265  # modify /etc/sysconfig/keyboard only in live-cd mode:
266  if [ -z "$INSTALLED" ] ; then
267
268    local LANGUAGE="$BOOT_LANGUAGE"
269    . /etc/grml/language-functions
270    # allow setting xkeyboard explicitly different than console keyboard
271    KXKEYBOARD="$(getbootparam 'xkeyboard' 2>>$DEBUG)"
272    if [ -n "$KXKEYBOARD" ]; then
273       XKEYBOARD="$KXKEYBOARD"
274       KDEKEYBOARD="$KXKEYBOARD"
275    elif [ -n "$KKEYBOARD" ]; then
276       XKEYBOARD="$KKEYBOARD"
277       KDEKEYBOARD="$KKEYBOARD"
278    fi
279
280    # duplicate of previous code to make sure /etc/grml/language-functions
281    # does not overwrite our values....
282    # now allow keyboard override by boot commandline for later use:
283    KKEYBOARD="$(getbootparam 'keyboard' 2>>$DEBUG)"
284    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
285    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
286    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
287    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
288
289    # write keyboard related variables to file for later use
290    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
291    if ! [ -e /etc/sysconfig/keyboard ] ; then
292       echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
293       echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
294       echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
295       echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
296    fi
297  fi
298
299  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
300
301  # activate unicode console if running within utf8 environment
302  if [ -r /etc/default/locale ] ; then
303     if grep -q "LANG=.*UTF" /etc/default/locale ; then
304        einfo "Setting up unicode environment."
305        unicode_start >>$DEBUG 2>&1 ; eend $?
306     fi
307  fi
308
309  # Set default keyboard before interactive setup
310  if [ -n "$KEYTABLE" ] ; then
311     einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
312     loadkeys -q $KEYTABLE &
313     eend $?
314  fi
315
316  # we have to set up all consoles, therefore loop it over all ttys:
317  NUM_CONSOLES=$(fgconsole --next-available 2>/dev/null)
318  if [ -n "$NUM_CONSOLES" ] ; then
319     NUM_CONSOLES=$(expr ${NUM_CONSOLES} - 1)
320     [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
321  fi
322  CUR_CONSOLE=$(fgconsole 2>/dev/null)
323
324  if [ -x "$(which setfont)" ] ; then
325     use_setfont=true
326  elif [ -x "$(which consolechars)" ] ; then
327     use_consolechars=true
328  else
329     eerror "Neither setfont nor consolechars tool present, can not set font."
330     eend 1
331     return 1
332  fi
333
334  if [ -n "$CHARMAP" ] ; then
335     einfo "Setting font to ${CHARMAP}"
336     RC=0
337     for vc in $(seq 0 ${NUM_CONSOLES}) ; do
338         if $use_setfont ; then
339           setfont -C /dev/tty${vc} $CHARMAP ; RC=$?
340         elif $use_consolechars ; then
341           consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
342         fi
343     done
344     if [ -n "$CUR_CONSOLE" ] ; then
345        [ "$CUR_CONSOLE" != "serial" ] && chvt $CUR_CONSOLE
346     fi
347     eend $RC
348  fi
349
350  if checkbootparam 'noconsolefont' ; then
351     ewarn "Skipping setting console font as requested on boot commandline." ; eend 0
352  else
353     if [ -n "$CONSOLEFONT" ] ; then
354        einfo "Setting font to ${CONSOLEFONT}"
355        RC=0
356        for vc in $(seq 0 ${NUM_CONSOLES}) ; do
357            if $use_setfont ; then
358              setfont -C /dev/tty${vc} ${CONSOLEFONT} ; RC=$?
359            elif $use_consolechars ; then
360              consolechars --tty=/dev/tty${vc} -f ${CONSOLEFONT} ; RC=$?
361            fi
362        done
363        if [ -n "$CUR_CONSOLE" ] ; then
364           [ "$CUR_CONSOLE" != "serial" ] && chvt $CUR_CONSOLE
365        fi
366        eend $RC
367     fi
368  fi
369
370  eoutdent
371 }
372 # }}}
373
374 # {{{ Set hostname
375 config_hostname(){
376  if checkbootparam 'hostname' ; then
377   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
378   if [ -z "$HOSTNAME" ] && [ -x /usr/bin/random-hostname ] ; then
379      einfo "Generating random hostname as no hostname was specified."
380      HOSTNAME="$(/usr/bin/random-hostname)"
381      eend $?
382   fi
383   einfo "Setting hostname to $HOSTNAME as requested."
384   grml-hostname $HOSTNAME >>$DEBUG ; RC=$?
385   [ "$RC" = "0" ] && hostname $HOSTNAME
386   eend $RC
387  else
388   hostname --file /etc/hostname
389  fi
390 }
391 # }}}
392
393 # fstabuser (needed when running from harddisk with username != grml {{{
394 config_userfstab(){
395   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
396   if [ -n "$CONFIG_FSTAB_USER" ] ; then
397      fstabuser="$CONFIG_FSTAB_USER"
398   else
399      fstabuser=$(getent passwd 1000 | cut -d: -f1)
400   fi
401   # if not yet set fall back to default 'grml' user
402   [ -n "$fstabuser" ] || fstabuser='grml'
403 }
404 # }}}
405
406 # {{{ Set clock (Local time is more often used than GMT, so it is default)
407 config_time(){
408  # don't touch the files if running from harddisk:
409  if [ -z "$INSTALLED" ]; then
410     # The default hardware clock timezone is stated as representing local time.
411     UTC="--localtime"
412     grep -q "^UTC=" /etc/default/rcS || echo "UTC=no" >> /etc/default/rcS
413     checkbootparam 'utc'       >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=yes|" /etc/default/rcS
414     checkbootparam 'gmt'       >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=yes|" /etc/default/rcS
415     checkbootparam 'localtime' >>$DEBUG 2>&1 && sed -i "s|^UTC=.*$|UTC=no|"  /etc/default/rcS
416     grep -q -i "^UTC=yes" /etc/default/rcS && UTC="-u"
417     # hwclock uses the TZ variable
418     KTZ="$(getbootparam 'tz' 2>>$DEBUG)"
419     [ -z "$KTZ" ] && [ -r /etc/timezone ] && KTZ=$(cat /etc/timezone)
420     if [ ! -f "/usr/share/zoneinfo/$KTZ" ] ; then
421        ewarn "Warning: unknown timezone $KTZ" ; eend 1
422        KTZ="Europe/Vienna"
423        ewarn "Falling back to timezone $KTZ" ; eend 0
424     fi
425
426     if ! [ -r /dev/rtc ] ; then
427       ewarn "Warning: realtime clock not available, trying to execute hwclock anyway." ; eend 0
428     fi
429
430     ERROR=$(TZ="$KTZ" hwclock $UTC -s 2>&1 | head -1) ; RC=$?
431     if [ -n "$ERROR" ] ; then
432        eindent
433        ERROR=$(TZ="$KTZ" hwclock $UTC -s --directisa 2>&1 | head -1)
434        if [ -n "$ERROR" ] ; then
435           eerror "Problem running hwclock: $ERROR" ; eend 1
436        fi
437        eoutdent
438     fi
439
440  fi
441 }
442 # }}}
443
444 # {{{ print kernel info
445 config_kernel(){
446   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
447   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
448   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
449   if [ -r /proc/cpuinfo ] ; then
450      if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
451        eindent
452        einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
453        eoutdent
454      fi
455   fi
456   if [ -d /proc/xen ] ; then
457      eindent
458      einfo 'Running kernel featuring support for Xen detected' ; eend 0
459      eoutdent
460   fi
461 }
462 # }}}
463
464 # {{{ ld.so.cache + depmod
465 config_ld_mod(){
466 if [ -n "$INSTALLED" ]; then
467  if ! [ -r /etc/grml.first.boot ] ; then
468   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
469   eindent
470 # Regenerate ld.so.cache and module dependencies on HD
471     einfo "Running ldconfig" ; ldconfig  ; eend $?
472     einfo "Running depmod"   ; depmod -a ; eend $?
473     touch /etc/grml.first.boot
474     eend 0
475   eoutdent
476  fi
477 fi
478 }
479 # }}}
480
481 # {{{ timezone
482 config_timezone(){
483  # don't touch the files if running from harddisk:
484  if [ -z "$INSTALLED" ]; then
485     KTZ="$(getbootparam 'tz' 2>>$DEBUG)"
486     if [ -n "$KTZ" ] ; then
487        if [ ! -f "/usr/share/zoneinfo/$KTZ" ]
488        then
489           ewarn "Warning: unknown timezone $KTZ"; eend 0
490        else
491           einfo "Setting timezone."
492           # update debconf
493           area=$(echo $KTZ | cut -d '/' -f1)
494           zone=$(echo $KTZ | cut -d '/' -f2)
495           echo "tzdata tzdata/Areas       select $area" | debconf-set-selections
496           echo "tzdata tzdata/Zones/$area select $zone" | debconf-set-selections
497           # update files
498           echo $KTZ > /etc/timezone
499           rm -f /etc/localtime
500           cp "/usr/share/zoneinfo/$KTZ" /etc/localtime ; eend $?
501        fi
502     fi
503  fi
504 }
505 # }}}
506
507 # small computer / nearly no ram {{{
508 config_small(){
509
510 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
511 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
512 eindent
513
514 if checkbootparam 'small'; then
515   einfo "Information: ${RAM} kB of RAM available." ; eend 0
516   einfo "Bootoption small detected. Activating small system."
517   if [ -r /etc/inittab.small ] ; then
518     mv /etc/inittab /etc/inittab.normal
519     mv /etc/inittab.small /etc/inittab
520   else
521     sed -i 's/^9/#&/' /etc/inittab
522     sed -i 's/^10/#&/' /etc/inittab
523     sed -i 's/^11/#&/' /etc/inittab
524     sed -i 's/^12/#&/' /etc/inittab
525   fi
526   /sbin/telinit q ; eend $?
527 else
528   if checkgrmlsmall ; then
529     if [[ $RAM -lt 25000 ]] ; then
530       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
531       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
532       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
533       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
534       /bin/zsh --login
535     else
536       einfo "Information: ${RAM} kB of RAM available." ; eend 0
537     fi
538   else
539     if [[ $RAM -lt 58000 ]] ; then
540       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
541       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
542       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
543       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
544       /bin/zsh --login
545     else
546       einfo "Information: ${RAM} kB of RAM available." ; eend 0
547     fi
548   fi
549 fi
550 eoutdent
551 }
552 # }}}
553
554 # skip startup of w3m {{{
555 config_fast(){
556 if checkbootparam 'fast'; then
557   ewarn "Bootoption fast detected. Skipping startup of grml-quickconfig."
558     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
559   /sbin/telinit q ; eend $?
560 fi
561 }
562 # }}}
563
564 # activate serial console {{{
565 config_console(){
566 if checkbootparam 'console'; then
567   local line
568   local ws
569   ws='   '
570
571   einfo "Bootoption for serial console detected:"
572
573   line="$CMDLINE x "
574   this=""
575   line="${line#*[$ws]}"
576   local telinitq=""
577   while [ -n "$line" ]; do
578     case "$this" in
579       console=*)
580         local serial="$this"
581         local device="${this%%,*}"
582         local device="${device##*=}"
583         if echo $serial | grep -q ttyS ; then
584           local option="${serial##*,}"
585           # default (works for kvm & CO):
586           local speed="115200,57600,38400,19200,9600,4800,2400,1200";
587           # ... unless overriden by command line:
588           case "$option" in
589             115200*) speed=115200 ;;
590              57600*) speed=57600 ;;
591              38400*) speed=38400 ;;
592              19200*) speed=19200 ;;
593               9600*) speed=9600 ;;
594               4800*) speed=4800 ;;
595               2400*) speed=2400 ;;
596               1200*) speed=1200 ;;
597           esac
598           eindent
599             einfo "Activating console login on device ${device} with speed ${speed}."
600             local number="${device#ttyS}"
601             sed -i "/^T$number:/d;/^#grmlserial#/iT$number:23:respawn:/bin/bash -c \"/sbin/getty -L $device -l /usr/bin/zsh-login $speed vt100 || sleep 30\"" /etc/inittab
602             eend $?
603             telinitq="1"
604           eoutdent
605         fi
606         ;;
607     esac
608     this="${line%%[$ws]*}"
609     line="${line#*[$ws]}"
610   done
611
612   if [ -n "$telinitq" ]; then
613     /sbin/telinit q
614   fi
615   eend $?
616 fi
617 }
618 # }}}
619
620 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
621 config_cdrom_perm(){
622 CDROMS=""
623 for DEVICE in /proc/ide/hd?; do
624  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
625 done
626 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
627 }
628 # }}}
629
630 # {{{ Bring up loopback interface now
631 config_local_net(){
632  if [ -z "$INSTALLED" ] ; then
633     if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
634        grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
635     else
636        ifconfig lo up
637     fi
638  fi
639 }
640 # }}}
641
642 # firewire devices {{{
643 # the raw1394 driver does not yet export info into SYSFS,
644 # so let's create raw1394 device manually
645 # http://www.michael-prokop.at/blog/index.php?p=352
646 config_firewire_dev(){
647 if checkbootparam 'nofirewiredev' ; then
648   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
649 else
650 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
651   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
652 #  cd /dev && MAKEDEV video1394 raw1394
653   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
654   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
655 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
656   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
657   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
658   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
659 fi
660 #fi
661 }
662 # }}}
663
664 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
665 # otherwise we will get: passwd: Authentication token lock busy
666 config_fix_passwd(){
667  if [ -z "$INSTALLED" ] ; then
668   touch /etc/.pwd.lock
669  fi
670 }
671 # }}}
672
673 # {{{ CD Checker
674 config_testcd(){
675 if [ -n "$TESTCD" ]; then
676    einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
677    einfo "Reading files and checking against GRML/md5sums, this may take a while..."
678    echo -n "${RED}"
679
680    if [ -n "${LIVECD_PATH}"/GRML ] ; then
681       ( cd "${LIVECD_PATH}"/GRML ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log ; RC=$? )
682    else
683       echo "${RED} *** Error: Could not find md5sum file.                           ***"
684    fi
685
686    if [ "$RC" = "0" ]; then
687       einfo "Everything looks OK" ; eend 0
688    else
689       eerror 'Checksum failed for theses files:' ; eend 1
690       egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
691       eerror 'Data on the grml medium is possibly incomplete/damaged or...'
692       eerror '... RAM of your computer is broken.' ; eend 1
693       einfon "Hit return to continue, or press the reset button to quit."
694      read a
695    fi
696
697    eend 0
698 fi
699 }
700 # }}}
701
702 # {{{ hardware detection via discover
703 config_discover(){
704 if checkbootparam 'nodisc' ; then
705   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
706 else
707  if [ -x /sbin/discover ] ; then
708   einfo "Discovering hardware. Trying to load the following modules in background:"
709    eindent
710    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
711    eoutdent
712   /sbin/discover-modprobe -v >>$DEBUG 2>&1 &
713   eend 0
714  else
715   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
716  fi
717 fi
718 }
719 # }}}
720
721 # {{{ hardware detection via hwinfo
722 config_hwinfo(){
723 if checkbootparam 'hwinfo' >>$DEBUG 2>&1; then
724   einfo "Discovering hardware via hwinfo:"
725   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
726   echo -n "  Loading modules: "
727   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
728   eend 0
729 fi
730 }
731 # }}}
732
733 # {{{ disable hotplug agents on request
734 config_hotplug_agent(){
735 if checkbootparam 'noagent' ; then
736   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
737   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
738   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
739   einfo "Disabling hotplug-agent(s) $AGENTNL"
740   for agent in $(echo -e $AGENTLIST) ; do
741     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
742   done
743   [ "$?" == "0" ] ; eend $?
744 fi
745 }
746 # }}}
747
748 # {{{ blacklist of hotplug-modules
749 config_hotplug_blacklist(){
750 if checkbootparam 'black' ; then
751   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
752   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
753   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
754   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
755   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
756   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
757   eend 0
758 fi
759 }
760 # }}}
761
762 # {{{ run hotplug
763 config_hotplug(){
764 if checkbootparam 'nohotplug' ; then
765   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
766 else
767   if [ -r /etc/init.d/hotplug ] ; then
768     einfo "Starting hotplug system in background."
769     /etc/init.d/hotplug start >>$DEBUG 2>>$DEBUG &
770     eend 0
771   elif [ -r /etc/init.d/hotplug-light ] ; then
772     einfo "Starting hotplug-light system in background."
773     /etc/init.d/hotplug-light start >>$DEBUG 2>>$DEBUG &
774     eend 0
775   else
776     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
777   fi
778 fi
779 }
780 # }}}
781
782 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
783 config_blacklist(){
784 if checkbootparam 'blacklist' ; then
785  if [ -z "$INSTALLED" ]; then
786   einfo "Bootoption blacklist found."
787   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
788   BLACKLIST_FILE='/etc/modprobe.d/grml.conf'
789   if [ -n "$BLACK" ] ; then
790     for module in $(echo ${BLACK//,/ }) ; do
791         einfo "Blacklisting module ${module} via ${BLACKLIST_FILE}."
792         echo "# begin entry generated by config_blacklist of grml-autoconfig" >> "$BLACKLIST_FILE"
793         echo "blacklist $module"     >> "$BLACKLIST_FILE"
794         echo "alias     $module off" >> "$BLACKLIST_FILE"
795         echo "# end   entry generated by config_blacklist of grml-autoconfig" >> "$BLACKLIST_FILE" ; eend $?
796     done
797   else
798    eerror "No given module for blacklist found. Blacklisting will not work therefore."
799   fi
800  else
801   ewarn "Backlisting via bootoption is not intended for use on harddisk installations." ; eend 1
802   eindent
803    einfo "Please blacklist the module(s) manually using the 'blacklist' script."
804   eoutdent
805  fi
806 fi
807 }
808 # }}}
809
810 # {{{ ACPI
811 config_acpi_apm(){
812 if [ -d /proc/acpi ]; then
813   if checkbootparam 'noacpi'; then
814     ewarn "Skipping ACPI Bios detection as requested via noacpi on boot commandline." ; eend 0
815   elif checkbootparam 'nogrmlacpi' ; then
816     ewarn "Skipping ACPI Bios detection as requested via nogrmlacpi on boot commandline." ; eend 0
817   else
818     einfo "ACPI Bios found, activating modules (disable via bootoption noacpi / nogrmlacpi): "
819     eindent
820     found=""
821     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
822       basename="${a##*/}"
823       basename="${basename%%.*}"
824       case "$basename" in *_acpi)
825        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
826       esac
827       modprobe $basename >>$DEBUG 2>&1 && found="yes"
828       local BASE="$BASE $basename"
829     done
830     if [ -n "$found" ] ; then
831       einfo "$BASE"  ; eend 0
832     else
833       ewarn "(none)" ; eend 1
834     fi
835     if ! ps x | grep -q /usr/sbin/acpid ; then
836       if ! [ -r /var/run/dbus/pid ] ; then
837         einfo "Starting acpi daemon."
838         /etc/init.d/acpid start >>$DEBUG 2>&1 ; eend $?
839       else
840         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
841         eerror "Solution: please activate acpid via /etc/runlevel.conf"
842         eend 1
843       fi
844     else
845       ewarn "acpi daemon already running."
846       eend 0
847     fi
848     eoutdent
849   fi
850 else
851 # APM
852   if checkbootparam 'noapm'; then
853     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
854   else
855     modprobe apm power_off=1 >>$DEBUG 2>&1
856     if [ "$?" = "0" ] ; then
857        if [ -x /etc/init.d/apmd ] ;then
858           einfo "APM Bios found, enabling power management functions."
859           /etc/init.d/apmd start ; eend $?
860        fi
861     else
862       eerror "Loading apm module failed." ; eend 1
863     fi
864   fi
865 fi
866 }
867 # }}}
868
869 # {{{ PCMCIA Check/Setup
870 # This needs to be done before other modules are being loaded (by hwsetup)
871 config_pcmcia(){
872 if checkbootparam 'nopcmcia'; then
873   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
874 else
875   if /usr/sbin/laptop-detect ; then
876     einfo "Detected Laptop - checking for PCMCIA." && eend 0
877     modprobe pcmcia_core >>$DEBUG 2>&1
878     # Try Cardbus or normal PCMCIA socket drivers
879     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
880     if [ "$?" = "0" ]; then
881       modprobe ds >>$DEBUG 2>&1
882       if [ -d /proc/bus/pccard ] ; then
883        if [ -x /sbin/cardmgr ] ; then
884         einfo "PCMCIA found, starting cardmgr."
885         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
886        else
887         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
888        fi
889       fi
890     fi
891   fi
892 fi
893 }
894 # }}}
895
896 # {{{ run software synthesizer via speakup
897 config_swspeak(){
898    if checkbootparam 'swspeak' ; then
899       einfo "Bootoption swspeak found."
900
901       if [ ! -d /proc/speakup/ ] && ! grep -q speakup_soft /proc/modules ; then
902          ewarn "Kernel does not support software speakup - trying to load kernel module:" ; eend 0
903          eindent
904          einfo "Loading speakup_soft"
905          if modprobe speakup_soft ; then
906             eend 0
907          else
908             flitewrapper "Fatal error setting up software speakup"
909             eend 1
910             return 1
911          fi
912          eoutdent
913       fi
914
915       if [ -d /proc/speakup/ ] || grep -q speakup_soft /proc/modules ; then
916          einfo "Kernel supports speakup." ; eend 0
917          eindent
918             einfo "Just run swspeak if you want to use software synthesizer via speakup."
919             flitewrapper "Finished activating software speakup. Just run swspeak when booting finished."
920          eoutdent
921       else
922          eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
923          flitewrapper "Kernel does not seem to support speakup. Sorry."
924       fi
925    fi
926 }
927 # }}}
928
929 # {{{ support hardware synthesizer via speakup
930 config_hwspeak(){
931    if checkbootparam 'speakup.synth' ; then
932       einfo "Bootoption speakup.synth found."
933       eindent
934
935       module="$(getbootparam 'speakup.synth' 2>>$DEBUG)"
936       if [ -z "$module" ] ; then
937          eerror "Sorry, no speakup module specified for bootoption speakup.synth."
938          flitewrapper "Sorry, no speakup module specified for bootoption speakup.synth."
939       else
940          einfo "Trying to load $module"
941          modprobe "speakup_${module}"
942          eend $?
943       fi
944
945       if [ -d /proc/speakup/ ] || grep -q speakup /proc/modules ; then
946          einfo "Kernel should support speakup now." ; eend 0
947          flitewrapper "Kernel should support speakup now."
948       else
949          eerror "Kernel or hardware do not seem to support speakup. Skipping hwspeak." ; eend 1
950          flitewrapper "Kernel or hardware do not seem to support speakup. Sorry."
951       fi
952
953       eoutdent
954
955    # hwspeak:
956    elif checkbootparam 'hwspeak' ; then
957       einfo "Bootoption hwspeak found."
958
959       if [ ! -d /proc/speakup/ ] && ! grep -q speakup /proc/modules ; then
960          ewarn "Kernel does not support hardware speakup - trying to load kernel modules:" ; eend 0
961          eindent
962          if ! [ -d "/lib/modules/${KERNEL}/extra/speakup/" ] ; then
963             eerror "Kernel does not provide speakup modules, sorry." ; eend 1
964          else
965            for module in $(find "/lib/modules/${KERNEL}/extra/speakup/" -name \*.ko | \
966                            sed 's#.*speakup/##g ; s#.ko$##g' | \
967                            grep -ve speakup_soft -ve speakup_dummy | sort -u) ; do
968               einfo "Trying to load $module"
969               modprobe $module
970               eend $?
971            done
972          fi
973          eoutdent
974       fi
975
976       if [ -d /proc/speakup/ ] || grep -q speakup /proc/modules ; then
977          einfo "Kernel should support speakup now." ; eend 0
978          flitewrapper "Kernel should support speakup now."
979       else
980          eerror "Kernel or hardware do not seem to support speakup. Skipping hwspeak." ; eend 1
981          flitewrapper "Kernel or hardware do not seem to support speakup. Sorry."
982       fi
983    fi
984 }
985 # }}}
986
987 # {{{ Check for blind option or brltty
988 config_blind(){
989 BLIND=""
990 checkbootparam 'blind' && BLIND="yes"
991 BRLTTY="$(getbootparam 'brltty' 2>>$DEBUG)"
992
993 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
994   if [ -x /sbin/brltty ]; then
995     # Blind option detected, start brltty now.
996     # modprobe serial_core parport_serial generic_serial && echo "done"
997     CMD=brltty
998     BRLTYPE=""
999     BRLDEV=""
1000     BRLTEXT=""
1001     if [ -n "$BRLTTY" ]; then
1002       # Extra options
1003       BRLTYPE="${BRLTTY%%,*}"
1004       R="${BRLTTY#*,}"
1005       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
1006         BRLTTY="$R"
1007         BRLDEV="${BRLTTY%%,*}"
1008         R="${BRLTTY#*,}"
1009         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
1010           BRLTTY="$R"
1011           BRLTEXT="${BRLTTY%%,*}"
1012           R="${BRLTTY#*,}"
1013         fi
1014       fi
1015     fi
1016     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
1017     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
1018     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
1019     einfo "Starting braille-display manager."
1020 #    ( exec $CMD & )
1021     ( sh -c "$CMD" & )
1022     sleep 2 && BLINDSOUND="yes"
1023     eend 0
1024   fi
1025 fi
1026 }
1027 # }}}
1028
1029 # {{{ Interactive configuration
1030 config_interactive(){
1031   ewarn "config_interactive is deprecated nowadays."
1032   ewarn "Please set CONFIG_INTERACTIVE='no' in /etc/grml/autoconfig" ; eend 0
1033 }
1034 # }}}
1035
1036 # {{{ AGP
1037 config_agp(){
1038 if checkbootparam 'forceagp' ; then
1039 # Probe for AGP. Hope this can fail safely
1040   grep -q "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
1041 fi
1042 }
1043 # }}}
1044
1045 # {{{ automount(er)
1046 config_automounter(){
1047 if checkbootparam 'automounter' ; then
1048   RUNLEVEL="$(runlevel)"
1049   AUTOMOUNTER=""
1050   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
1051
1052 addautomount(){
1053 # /dev/ice  options
1054   d="${1##*/}"
1055   if [ -n "$AUTOMOUNTER" ]; then
1056     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
1057     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
1058     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
1059     anew="$d        -fstype=auto,$2 :$i"
1060     grep -q "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
1061     AUTOMOUNTS="$AUTOMOUNTS $d"
1062     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
1063   else
1064     [ -d /mnt/$d ] && mkdir -p /mnt/$d
1065     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
1066   fi
1067   grep -q "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
1068 }
1069
1070   AUTOMOUNTS="floppy cdrom"
1071 # Add new devices to /etc/fstab and /etc/auto.mnt
1072   for i in /dev/cdrom?*; do
1073     if [ -L $i ]; then
1074       addautomount "$i" "ro"
1075     fi
1076   done
1077 fi
1078
1079 if [ -n "$AUTOMOUNTER" ]; then
1080 # Check for floppy dir, reinstall with automounter
1081   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
1082   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
1083   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
1084   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
1085   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
1086   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
1087   rm -f /etc/fstab.new
1088 # Replace paths from bootfloppy
1089   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
1090   mv -f /etc/fstab.new /etc/fstab
1091 # Start automounter now
1092   einfo "Starting automounter for ${AUTOMOUNTS}."
1093   /etc/init.d/autofs start >>$DEBUG ; eend $?
1094 fi
1095 }
1096 # }}}
1097
1098 # {{{ Collect partitions from /proc/partitions first for enabling DMA
1099 check_partitions(){
1100 partitions=""
1101 IDEDISKS=""
1102 while read major minor blocks partition relax; do
1103   partition="${partition##*/}"
1104   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
1105   case "$partition" in
1106     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
1107     sd?) ;;                                               # SCSI Harddisk, entire disk
1108 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
1109     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
1110   esac
1111 done <<EOT
1112 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
1113 EOT
1114 }
1115 check_partitions >/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
1116 # }}}
1117
1118 # {{{ Enable DMA for all IDE drives now if not disabled
1119 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
1120 config_dma(){
1121 if checkbootparam 'nodma'; then
1122   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
1123 else
1124   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
1125     if test -d /proc/ide/$d; then
1126       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
1127         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
1128         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
1129         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
1130         echo "using_dma:1" >/proc/ide/$d/settings
1131         eend 0
1132       fi
1133     fi
1134   done
1135 fi
1136 }
1137 # }}}
1138
1139 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
1140 config_fstab(){
1141
1142 NOSWAP="yes" # we do not use swap by default!
1143 if checkbootparam 'swap' || checkbootparam 'anyswap' ; then
1144    NOSWAP=''
1145    checkbootparam 'anyswap' && export ANYSWAP='yes' || export ANYSWAP=""
1146 fi
1147
1148 if checkbootparam 'nofstab' || checkbootparam 'forensic' ; then
1149   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
1150 else
1151   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
1152   iszsh && setopt nonomatch
1153   if [ -x /usr/sbin/rebuildfstab ] ; then
1154      config_userfstab || fstabuser=grml
1155      /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
1156   else
1157      ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
1158   fi
1159 fi # checkbootparam nofstab/forensic
1160
1161 # Scan for swap, config, homedir - but only in live-mode
1162 if [ -z "$INSTALLED" ] ; then
1163    [ -z "$NOSWAP" ] && einfo "Searching for swap partition(s) as requested."
1164    GRML_IMG=""
1165    GRML_SWP=""
1166    HOMEDIR="$(getbootparam 'home')"
1167    if [ -n "$partitions" ]; then
1168       while read p m f relax; do
1169         case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
1170         partoptions="users,exec"
1171         fnew=""
1172         # it's a swap partition?
1173         case "$f" in swap)
1174           eindent
1175           if [ -n "$NOSWAP" ]; then
1176              ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)"
1177              eend 0
1178           else
1179              case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
1180                    S1SUSP|S2SUSP|pmdisk|[zZ]*)
1181                      if [ -n "$ANYSWAP" ] ; then
1182                         einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
1183                         swapon $p 2>>$DEBUG ; eend $?
1184                      else
1185                         ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
1186                      fi
1187                      ;;
1188                    *)
1189                      if [[ "$p" == LABEL* ]] ; then
1190                         p=$(blkid -t $p | awk -F: '{print $1}')
1191                      fi
1192                      if grep -q $p /proc/swaps ; then
1193                         ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
1194                      else
1195                         if [ -b "$p" ] ; then
1196                         einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1197                         swapon $p 2>>$DEBUG ; eend $?
1198                         else
1199                         ewarn "$p is not a valid block device - not using it therefore." ; eend 0
1200                         fi
1201                      fi
1202                      ;;
1203              esac # dd-check
1204           fi # -n "$NOSWAP
1205           eoutdent
1206           continue
1207           ;;
1208         esac # it's a swap partition?
1209
1210         # mount read-only
1211         MOUNTOPTS="ro"
1212         case "$f" in
1213           vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1214           ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1215           *) continue ;;
1216           # *) NONEFOUND='1'; continue ;;
1217         esac
1218
1219         # use a swapfile
1220         if [ -z "$NOSWAP" ] ; then
1221            mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG && MOUNTED=1 || continue
1222            # Activate swapfile, if exists
1223            SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1224         fi
1225         if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1226            mount -o remount,rw $m && MOUNTED=1
1227            if swapon "$SWAPFILE" 2>>$DEBUG ; then
1228               eindent
1229                 einfo "Using GRML swapfile ${WHITE}${SWAPFILE}${NORMAL}."
1230               eoutdent
1231               fnew="$SWAPFILE swap swap defaults 0 0"
1232               grep -q "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1233               GRML_SWP="$GRML_SWP $SWAPFILE"
1234               eend 0
1235            fi
1236            mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1237         fi
1238
1239         # use a image as home
1240         IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1241         if [ -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1242            if [ -n "$HOMEDIR" ]; then
1243               if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1244                  continue
1245               fi
1246            fi
1247            if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1248               GRML_IMG="$IMAGE"
1249               mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1250            fi
1251         fi
1252         eend 0
1253
1254         # Umount, if not in use
1255         [ -n "$MOUNTED" ] && umount -r $m 2>/dev/null
1256
1257       done <<EOT
1258       $(cat /etc/fstab)
1259 EOT
1260    fi # -n $partitions
1261 fi # -z $INSTALLED
1262 }
1263 # }}}
1264
1265 # {{{ Mouse
1266 config_mouse(){
1267 if [ -n "$MOUSE_DEVICE" ] ; then
1268   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1269 fi
1270 }
1271 # }}}
1272
1273 # {{{ IPv6 configuration
1274 # Load IPv6 kernel module and print IP adresses
1275 config_ipv6(){
1276 if checkbootparam 'ipv6'; then
1277   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1278   modprobe ipv6
1279   # we probably need some time until stateless autoconfiguration has happened
1280   sleep 2
1281   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1282   for DEVICE in `echo "$NETDEVICES"`; do
1283     eindent
1284       einfo "$DEVICE:"
1285       ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1286       COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1287       eindent
1288         for ADDR in `echo "$ADDRESSES"` ; do
1289             einfo "$ADDR"
1290         done
1291         if [ "$COUNT" -eq "0" ] ; then
1292            einfo "(none)" ; eend 1
1293         fi
1294       eoutdent
1295     eoutdent
1296   done
1297   eend 0
1298 fi
1299 }
1300 # }}}
1301
1302 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1303 config_dhcp(){
1304 if checkbootparam 'nodhcp'; then
1305   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1306 else
1307   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1308   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1309   for DEVICE in `echo "$NETDEVICES"` ; do
1310     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1311     trap 2 3 11
1312     ifconfig $DEVICE up >>$DEBUG 2>&1
1313     ( pump -i $DEVICE --script=/usr/lib/grml-autoconfig/pump-runparts >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1314     trap "" 2 3 11
1315     sleep 1
1316     eend 0
1317   done
1318   if [ -n "$INSTALLED" ] ; then
1319      ewarn 'If you want to disable automatic DHCP requests set CONFIG_DHCP=no in /etc/grml/autoconfig.'
1320      eend 0
1321   fi
1322 fi
1323 }
1324 # }}}
1325
1326 # {{{ CPU-detection
1327 config_cpu(){
1328 if checkbootparam 'nocpu'; then
1329   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1330   return 0
1331 fi
1332
1333 if [[ $(grep -c processor /proc/cpuinfo) -gt 1 ]] ; then
1334    einfo "Detecting CPU:"
1335    CPU=$(awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1336    echo $CPU | sed 's/ \{1,\}/ /g'
1337    eend 0
1338 else
1339    einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1340 fi
1341
1342 # Virtual Box supports ACPI and laptop-detect would return with '0', so check for it:
1343 if [ -r /proc/acpi/battery/BAT0/info ] && grep -q 'OEM info:.*innotek' /proc/acpi/battery/BAT0/info ; then
1344    einfo 'Virtual Box detected, skipping cpufreq setup.' ; eend 0
1345    return 0
1346 fi
1347
1348 if [ -x /etc/init.d/loadcpufreq ] ; then
1349    einfo "Trying to set up cpu frequency scaling:"
1350    eindent
1351    SKIP_CPU_GOVERNOR=''
1352    LOADCPUFREQ=$(mktemp)
1353    /etc/init.d/loadcpufreq start >"$LOADCPUFREQ" 2>&1 ; RC=$?
1354    if grep -q FATAL "$LOADCPUFREQ" ; then
1355       eindent
1356         SKIP_CPU_GOVERNOR=1
1357         oldIFS="$IFS"
1358         IFS="
1359 "
1360          for line in $(grep FATAL "$LOADCPUFREQ" | sed 's/.*FATAL: //; s/ (.*)//') ; do
1361              eerror "$line" ; eend $RC
1362          done
1363          IFS="$oldIFS"
1364       eoutdent
1365    elif grep -q done "$LOADCPUFREQ" ; then
1366       MODULE=$(grep done "$LOADCPUFREQ" | sed 's/.*done (\(.*\))./\1/')
1367       if [ -n "$MODULE" -a "$MODULE" != none ]; then
1368          einfo "Loading cpufreq kernel module $MODULE" ; eend 0
1369       else
1370          ewarn "Could not find an appropriate kernel module for cpu frequency scaling." ; eend 1
1371       fi
1372    fi
1373
1374    rm -f $LOADCPUFREQ
1375
1376    if [ -z "$SKIP_CPU_GOVERNOR" ] ; then
1377       einfo "Loading cpufreq_ondemand, setting ondemand governor"
1378       RC=0
1379       if modprobe cpufreq_ondemand ; RC=$? ; then
1380          for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
1381             echo ondemand > $file
1382          done
1383       fi
1384       eend $RC
1385    fi # cpu-governor
1386
1387    eoutdent
1388 fi
1389 }
1390 # }}}
1391
1392 # {{{ autostart of ssh
1393 config_ssh(){
1394 if checkbootparam 'ssh' ; then
1395    SSH_PASSWD=''
1396    SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1397    einfo "Bootoption ssh found, trying to set password for user grml."
1398    eindent
1399    if [ -z "$SSH_PASSWD" ] ; then
1400       if [ -x /usr/bin/apg ] ; then
1401          SSH_PASSWD="$(apg -M NL -a 0 -m 8 -x 12 -n 1)"
1402       elif [ -x /usr/bin/gpw ] ; then
1403          SSH_PASSWD="$(gpw 1)"
1404       elif [ -x /usr/bin/pwgen ] ; then
1405          SSH_PASSWD="$(pwgen -1 8)"
1406       elif [ -x /usr/bin/hexdump ] ; then
1407          SSH_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
1408       elif [ -n "$RANDOM" ] ; then
1409          SSH_PASSWD="grml${RANDOM}"
1410       else
1411          SSH_PASSWD=''
1412          eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
1413          eend 1
1414       fi
1415
1416       if [ -n "$SSH_PASSWD" ] ; then
1417          ewarn "No given password for ssh found. Using random password: $SSH_PASSWD" ; eend 0
1418       fi
1419    fi
1420    eoutdent
1421
1422    # finally check if we have a password we can use:
1423    if [ -n "$SSH_PASSWD" ] ; then
1424       # chpasswd sucks, seriously.
1425       if chpasswd --help 2>&1 | grep -q -- '-m,' ; then
1426         echo "grml:$SSH_PASSWD" | chpasswd -m
1427       else
1428         echo "grml:$SSH_PASSWD" | chpasswd
1429       fi
1430    fi
1431
1432    einfo 'Starting secure shell server in background.'
1433    /etc/init.d/rmnologin start >>$DEBUG 2>>$DEBUG
1434    /etc/init.d/ssh start >>$DEBUG 2>>$DEBUG &
1435    eend $?
1436
1437    eindent
1438    ewarn 'Warning: please change the password for user grml as soon as possible!'
1439    eoutdent
1440 fi
1441 }
1442 # }}}
1443
1444 # {{{ autostart of x11vnc
1445 config_vnc(){
1446
1447 USER=grml # TODO: make it dynamically configurable
1448 if checkbootparam 'vnc' ; then
1449    VNC_PASSWD=''
1450    VNC_PASSWD="$(getbootparam 'vnc' 2>>$DEBUG)"
1451    einfo "Bootoption vnc found, trying to set password for user $USER."
1452    eindent
1453    if [ -z "$VNC_PASSWD" ] ; then
1454       if [ -x /usr/bin/apg ] ; then
1455          VNC_PASSWD="$(apg -M NL -a 0 -m 8 -x 12 -n 1)"
1456       elif [ -x /usr/bin/gpw ] ; then
1457          VNC_PASSWD="$(gpw 1)"
1458       elif [ -x /usr/bin/pwgen ] ; then
1459          VNC_PASSWD="$(pwgen -1 8)"
1460       elif [ -x /usr/bin/hexdump ] ; then
1461          VNC_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
1462       elif [ -n "$RANDOM" ] ; then
1463          VNC_PASSWD="${USER}${RANDOM}"
1464       else
1465          VNC_PASSWD=''
1466          eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
1467          eend 1
1468       fi
1469
1470       if [ -n "$VNC_PASSWD" ] ; then
1471          ewarn "No given password for vnc found. Using random password: $VNC_PASSWD" ; eend 0
1472       fi
1473    fi
1474    eoutdent
1475
1476    # finally check if we have a password we can use:
1477    if [ -n "$VNC_PASSWD" ] ; then
1478
1479       VNCDIR="/home/${USER}/.vnc"
1480       [ -d "$VNCDIR" ] || mkdir "$VNCDIR"
1481
1482       if [ ! -x /usr/bin/x11vnc ] ; then
1483          eerror "Error: x11vnc not found - can not set up vnc. Please make sure to install the x11vnc package."
1484          eend 1
1485       else
1486          /usr/bin/x11vnc -storepasswd "$VNC_PASSWD" "$VNCDIR"/passwd ; eend $?
1487          /bin/chown -R "$USER": "$VNCDIR"
1488       fi
1489    fi
1490    if checkbootparam 'vnc_connect' ; then
1491       VNC_CONNECT=''
1492       VNC_CONNECT="$(getbootparam 'vnc_connect' 2>>$DEBUG)"
1493       einfo "Bootoption vnc_connect found, will start vnc with connect to $VNC_CONNECT."
1494       #store the options in a file
1495       VNCDIR="/home/${USER}/.vnc"
1496       [ -d "$VNCDIR" ] || mkdir "$VNCDIR"
1497       echo " --connect $VNC_CONNECT " >> $VNCDIR/options
1498    fi
1499 fi
1500 }
1501 # }}}
1502
1503 # {{{ set password for user grml
1504 config_passwd(){
1505 if checkbootparam 'passwd' >>$DEBUG 2>&1; then
1506   einfo "Bootoption passwd found."
1507   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1508   if [ -n "$PASSWD" ] ; then
1509     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1510   else
1511     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1512   fi
1513   eindent
1514     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1515   eoutdent
1516 fi
1517 }
1518 # }}}
1519
1520 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1521 config_homedir(){
1522 if checkbootparam 'home' ; then
1523    ewarn "The \"home\" bootoption is deprecated, please use the persistency feature instead."; eend 1
1524 fi
1525 }
1526 # }}}
1527
1528 # {{{ Sound
1529 config_mixer () {
1530    if ! [ -x /usr/bin/amixer ] ; then
1531       eerror "amixer binary not available. Can not set sound volumes therefore."
1532       eend 1
1533    else
1534       if ! [ -r /proc/asound/cards ] ; then
1535          ewarn "No soundcard present, skipping mixer settings therefore."
1536          eend 0
1537          return
1538       fi
1539
1540       for card in $(cat /proc/asound/cards| grep -e '^\s*[0-9]' | awk '{print $1}') ; do
1541          einfo "Configuring soundcard $(cat /proc/asound/cards| grep -e "$card" | awk -F\[ '{print $2}' | awk '{print $1}')"
1542          eindent
1543
1544          if checkbootparam 'vol' ; then
1545             VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1546             if [ -z "$VOL" ] ; then
1547                eerror "Bootoption vol found but no volume level/parameter given. Using defaults (75%)."
1548                VOL='75'
1549                eend 1
1550             fi
1551          else
1552             VOL='75'
1553          fi
1554
1555          if checkbootparam 'nosound' ; then
1556             einfo "Muting sound devices on request."
1557             ERROR=$(amixer -q set Master mute)
1558             RC=$?
1559             if [ -n "$ERROR" ] ; then
1560                eindent
1561                eerror "Problem muting sound devices: $ERROR"
1562                eoutdent
1563             fi
1564             eend $RC
1565          elif [ -z "$INSTALLED" ] ; then
1566             einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1567
1568             if checkbootparam 'micvol' ; then
1569                MICVOL="$(getbootparam 'micvol' 2>>$DEBUG)"
1570             else
1571                MICVOL=0
1572             fi
1573
1574             for CONTROL in Master PCM ; do
1575                if amixer -q | grep -q "Simple mixer control.*$CONTROL" ; then
1576                   amixer -q set "${CONTROL}" "${VOL}"%
1577                   eend $?
1578                fi
1579             done
1580
1581             if [ ${MICVOL} -ne 0 ] ; then
1582                einfo "Setting microphone to ${WHITE}${MICVOL}${NORMAL}."
1583                amixer -q set "Mic" $MICVOL &> /dev/null
1584                eend $?
1585             fi
1586          fi # checkbootparam 'nosound'
1587          eoutdent
1588       done
1589    fi
1590 }
1591 # }}}
1592
1593 # {{{ modem detection
1594 config_modem(){
1595 if checkbootparam 'nomodem'; then
1596   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1597 else
1598   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1599      if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1600         einfo "AC97 modem controller detected. Start it running 'Start sl-modem-daemon'."
1601         eend 0
1602      fi
1603   fi
1604 fi
1605 }
1606 # }}}
1607
1608 # {{{ keyboard add-ons
1609 config_setkeycodes(){
1610 if checkbootparam 'setkeycodes' ; then
1611  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1612   # MS MM keyboard add-on
1613   # fix
1614   setkeycodes e001 126 &>/dev/null
1615   setkeycodes e059 127 &>/dev/null
1616   # fn keys
1617   setkeycodes e03b 59 &>/dev/null
1618   setkeycodes e008 60 &>/dev/null
1619   setkeycodes e007 61 &>/dev/null
1620   setkeycodes e03e 62 &>/dev/null
1621   setkeycodes e03f 63 &>/dev/null
1622   setkeycodes e040 64 &>/dev/null
1623   setkeycodes e041 65 &>/dev/null
1624   setkeycodes e042 66 &>/dev/null
1625   setkeycodes e043 67 &>/dev/null
1626   setkeycodes e023 68 &>/dev/null
1627   setkeycodes e057 87 &>/dev/null
1628   setkeycodes e058 88 &>/dev/null
1629   # hp keycodes
1630   setkeycodes e00a 89 e008 90 &>/dev/null
1631  eend 0
1632 fi
1633 }
1634 # }}}
1635
1636 # {{{ wondershaper
1637 config_wondershaper(){
1638  if checkbootparam 'wondershaper' ; then
1639     WONDER="$(getbootparam 'wondershaper' 2>>$DEBUG)"
1640     CMD=wondershaper
1641     DEVICE=""
1642     DOWNSTREAM=""
1643     UPSTREAM=""
1644     if [ -n "$WONDER" ]; then
1645       # Extra options
1646       DEVICE="${WONDER%%,*}"
1647       R="${WONDER#*,}"
1648       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1649         WONDER="$R"
1650         DOWNSTREAM="${WONDER%%,*}"
1651         R="${WONDER#*,}"
1652         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1653           WONDER="$R"
1654           UPSTREAM="${WONDER%%,*}"
1655           R="${WONDER#*,}"
1656         fi
1657       fi
1658     fi
1659     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1660     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1661     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1662     einfo "Starting wondershaper (${CMD}) in background."
1663     ( sh -c $CMD & ) && eend 0
1664  fi
1665 }
1666 # }}}
1667
1668 # {{{ syslog-ng
1669 config_syslog(){
1670  if checkbootparam 'nosyslog'; then
1671     ewarn "Not starting syslog daemon as requested on boot commandline." ; eend 0
1672  else
1673     SYSLOGD=''
1674     [ -x /etc/init.d/syslog-ng ] && SYSLOGD='syslog-ng'
1675     [ -x /etc/init.d/rsyslog   ] && SYSLOGD='rsyslog'
1676     [ -x /etc/init.d/dsyslog   ] && SYSLOGD='dsyslog'
1677     [ -x /etc/init.d/sysklogd  ] && SYSLOGD='sysklogd'
1678     [ -x /etc/init.d/inetutils-syslogd ] && SYSLOGD='inetutils-syslogd'
1679
1680     if [ -z "$SYSLOGD" ] ; then
1681        eerror "No syslog daemon found." ; eend 1
1682     else
1683        einfo "Starting $SYSLOGD in background."
1684        /etc/init.d/$SYSLOGD start >>$DEBUG &
1685        eend 0
1686     fi
1687  fi
1688 }
1689 # }}}
1690
1691 # {{{ gpm
1692 config_gpm(){
1693  if checkbootparam 'nogpm'; then
1694   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1695  else
1696    if ! [ -r /dev/input/mice ] ; then
1697       eerror "No mouse found - not starting GPM." ; eend 1
1698    else
1699       einfo "Starting gpm in background."
1700       /etc/init.d/gpm start >>$DEBUG &
1701       # ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start >>$DEBUG ) &
1702       eend 0
1703    fi
1704  fi
1705 }
1706 # }}}
1707
1708 # {{{ services
1709 config_services(){
1710  if checkbootparam 'services' ; then
1711     SERVICE="$(getbootparam 'services' 2>>$DEBUG)"
1712     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1713     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1714     einfo "Starting service(s) ${SERVICENL} in background."
1715     for service in $(echo -e $SERVICELIST) ; do
1716        /etc/init.d/${service} start >>$DEBUG &
1717     done
1718     [ "$?" == "0" ] ; eend $?
1719  fi
1720 }
1721 # }}}
1722
1723 # {{{ remote files
1724 get_remote_file() {
1725   [ "$#" -eq 2 ] || ( echo "Error: wrong parameter for get_remote_file()" ; return 1 )
1726   SOURCE=$(eval echo "$1")
1727   TARGET="$2"
1728   getconfig() {
1729   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 --tries=1 \
1730        --read-timeout=10 ${SOURCE} -O ${TARGET} && return 0 || return 1
1731   }
1732   einfo "Trying to get ${WHITE}${TARGET}${NORMAL}"
1733   counter=10
1734   while ! getconfig && [[ "$counter" != 0 ]] ; do
1735     echo -n "Sleeping for 1 second and trying to get config again... "
1736     counter=$(( counter-1 ))
1737     echo "$counter tries left" ; sleep 1
1738   done
1739   if [ -s "$TARGET" ] ; then
1740     einfo "Downloading was successfull." ; eend 0
1741     einfo "md5sum of ${WHITE}${TARGET}${NORMAL}: "
1742     md5sum ${TARGET} ; eend 0
1743     return 0;
1744   else
1745     einfo "Sorry, could not fetch ${SOURCE}" ; eend 1
1746     return 1;
1747  fi
1748 }
1749 # }}}
1750
1751 # {{{ config files
1752 config_netconfig(){
1753  if checkbootparam 'netconfig' ; then
1754   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1755   CONFIGFILE='/tmp/netconfig.grml'
1756
1757   if get_remote_file ${CONFIG} ${CONFIGFILE} ; then
1758     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1759   fi
1760
1761  fi
1762 }
1763 # }}}
1764
1765 # {{{ remote scripts
1766 config_netscript() {
1767  if checkbootparam 'netscript' ; then
1768   CONFIG="$(getbootparam 'netscript' 2>>$DEBUG)"
1769   SCRIPTFILE='/tmp/netscript.grml'
1770
1771   if get_remote_file ${CONFIG} ${SCRIPTFILE} ; then
1772     chmod +x ${SCRIPTFILE}
1773     einfo "Running ${WHITE}${SCRIPTFILE}${NORMAL}:" && NETSCRIPT=${CONFIG} ${SCRIPTFILE} ; eend $?
1774   fi
1775
1776  fi
1777 }
1778 # }}}
1779
1780 # {{{ blindsound
1781 config_blindsound(){
1782  if checkbootparam 'blind' ; then
1783     beep
1784     flitewrapper "welcome to the gremel system"
1785  fi
1786 }
1787 # }}}
1788
1789 # {{{ welcome sound
1790 config_welcome(){
1791  if checkbootparam 'welcome' ; then
1792     flitewrapper "welcome to the gremel system"
1793  fi
1794 }
1795 # }}}
1796
1797 # {{{ fix/workaround for unionfs
1798 fix_unionfs(){
1799   if [ -z "$INSTALLED" ]; then
1800    touch /var/cache/apt/*cache.bin
1801   fi
1802 }
1803 # }}}
1804
1805 # {{{ create all /mnt-directories
1806 create_mnt_dirs(){
1807   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1808   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1809 }
1810 # }}}
1811
1812 # {{{ start X window system via grml-x
1813 config_x_startup(){
1814 # make sure we start X only if startx is used *before* a nostartx option
1815 # so it's possible to disable automatic X startup using nostart
1816 if checkbootparam 'startx' && ! echo "$CMDLINE" | grep -q 'startx.*nostartx' ; then
1817  if [ -x "$(which X)" ] ; then
1818   if [ -z "$INSTALLED" ] ; then
1819    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1820    if [ -z "$WINDOWMANAGER" ] ; then
1821      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1822      WINDOWMANAGER="wm-ng"
1823    else
1824      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1825    fi
1826    einfo "Setting up and invoking grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1827    config_userfstab || fstabuser='grml'
1828  cat>|/etc/init.d/xstartup<<EOF
1829 #!/bin/sh
1830 su $fstabuser -c "/usr/bin/grml-x $WINDOWMANAGER"
1831 EOF
1832    chmod 755 /etc/init.d/xstartup
1833
1834    # adjust inittab for xstartup
1835    if grep -q '^6:' /etc/inittab ; then
1836       sed -i 's|^6:.*|6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /usr/bin/zsh-login" >/dev/tty6 2>\&1 </dev/tty6|' /etc/inittab
1837    else # just append tty6 to inittab if no definition is present:
1838       echo '6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /usr/bin/zsh-login" >/dev/tty6 2>&1 < /dev/tty6' >> /etc/inittab
1839    fi
1840
1841    /sbin/telinit q ; eend $?
1842
1843    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
1844       sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1845    else
1846       echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
1847    fi
1848
1849   else
1850     eerror "We are not running in live mode - startx will not work, skipping it."
1851     eerror " -> Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1852   fi
1853  else
1854    eerror "/usr/X11R6/bin/X is not present on this grml flavour."
1855    eerror "  -> Boot parameter startx does not work therefore." ; eend 1
1856  fi
1857 fi
1858 }
1859 # }}}
1860
1861 # {{{ configuration framework
1862 config_extract(){
1863 if checkbootparam 'extract' ; then
1864  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1865  EXTRACTOPTIONS="-- -x $EXTRACT"
1866 fi
1867 }
1868
1869 config_finddcsdir() {
1870 #  - If no GRMLCFG partition is found and noautoconfig is _not_ given
1871 #    on the command line, nothing is changed and the dcs files are
1872 #    searched within the .iso, $dcs-dir is set to the root directory
1873 #    within the .iso
1874 #  - If a GRMLCFG partition is found, $dcs-dir is set to the root of
1875 #    the GRMLCFG partition unless noautoconfig is set. If noautoconfig is
1876 #    set, $dcs-dir is set to the root directory within the .iso.
1877 #  - If myconfig=foo is set on the command line, $dcs-dir is set to
1878 #    foo, even if a GRMLCFG partition is present.
1879 DCSDIR=""
1880 DCSMP="/mnt/grml"
1881 if checkbootparam 'noautoconfig' || checkbootparam 'forensic' ; then
1882   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1883 else
1884   if [ -z "$INSTALLED" ] ; then
1885     if checkbootparam 'myconfig' ; then
1886       DCSDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1887       if [ -z "$DCSDEVICE" ]; then
1888         eerror "Error: No device for bootoption myconfig provided." ; eend 1
1889       fi # [ -z "$DCSDEVICE" ]
1890     elif checkvalue $CONFIG_MYCONFIG; then # checkbootparam myconfig
1891       einfo "Searching for device(s) labeled with GRMLCFG. (Disable this via boot option: noautoconfig)" ; eend 0
1892       eindent
1893       # We do need the following fix so floppy disk is available to blkid in any case :-/
1894       if [ -r /dev/fd0 ] ; then
1895         einfo "Floppy device detected. Trying to access floppy disk."
1896         if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 >>$DEBUG 2>&1 ; then
1897            blkid /dev/fd0 >>$DEBUG 2>&1
1898         fi
1899       fi
1900       DCSDEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1901       if [ -n "$DCSDEVICE" ]; then
1902         DCSMP="/mnt/grmlcfg"
1903       fi
1904       eoutdent
1905     fi
1906
1907     # if not specified/present then assume default:
1908     if [ -z "$DCSDEVICE" ]; then
1909       DCSDIR="/live/image"
1910     else
1911       eindent
1912       einfo "debs, config, scripts are read from $DCSDEVICE." ; eend 0
1913       DCSDIR="$(< /proc/mounts awk -v DCSDEV=$DCSDEVICE '{if ($1 == DCSDEV) { print $2 }}')"
1914       if [ -n "$DCSDIR" ]; then
1915         ewarn "$DCSDEVICE already mounted on $DCSDIR"; eend 0
1916       else
1917         [ -d $DCSMP ] || mkdir $DCSMP
1918         umount $DCSMP >>$DEBUG 2>&1 # make sure it is not mounted
1919         mount -o ro -t auto $DCSDEVICE  $DCSMP ; RC="$?"
1920         if [[ $RC == 0 ]]; then
1921           einfo "Successfully mounted $DCSDEVICE to $DCSMP (readonly)." ; eend 0
1922         else
1923           eerror "Error: mounting $DCSDEVICE to $DCSMP (readonly) failed." ; eend 1
1924         fi
1925         DCSDIR="$DCSMP"
1926       fi
1927       eoutdent
1928     fi
1929   fi
1930 fi
1931
1932 if [ -n "$DCSDIR" -a "$DCSDIR" != "/live/image" ] ; then
1933   einfo "Debs, config, scripts (if present) will be read from $DCSDIR." ; eend 0
1934 elif checkbootparam 'debs' || checkbootparam 'config' || checkbootparam 'scripts'; then
1935   einfo "Debs, config, scripts will be read from the live image directly." ; eend 0
1936 fi
1937 }
1938
1939
1940 config_partconf() {
1941 if checkbootparam 'partconf' ; then
1942  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1943  if [ -n "$MOUNTDEVICE" ]; then
1944    [ -d /mnt/grml ] || mkdir /mnt/grml
1945    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1946     if [[ $RC == 0 ]]; then
1947       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1948       einfo "Copying files from $MOUNTDEVICE over grml system."
1949       for file in `cat /etc/grml/partconf` ; do
1950         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1951         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1952       done && eend 0
1953     else
1954       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1955     fi # mount $MOUNTDEVICE
1956    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1957  else
1958    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1959  fi # [ -n "$MOUNTDEVICE" ]
1960 fi
1961 }
1962 # }}}
1963
1964 # {{{ /cdrom/.*-options
1965 config_debs(){
1966 if checkbootparam 'debs' ; then
1967    iszsh && setopt localoptions shwordsplit
1968    DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1969    if ! echo $DEBS | grep -q '/'; then
1970      # backwards compatibility: if no path is given get debs from debs/
1971      DEBS="debs/$DEBS"
1972    fi
1973    einfo "Tring to install debian package(s) ${DEBS}"
1974    DEBS="$(eval echo ${DCSDIR}/$DEBS)"
1975    dpkg -i $DEBS ; eend $?
1976 fi
1977 }
1978
1979 config_scripts(){
1980 if checkbootparam 'scripts' || [ "$DCSMP" = "/mnt/grmlcfg" ]; then
1981    SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1982    if [ -d ${DCSDIR}/scripts ] && [ -z "$SCRIPTS" ]; then
1983      SCRIPTS="$(cd ${DCSDIR}/scripts; /bin/ls -1d [Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1984    fi
1985    if ! echo $SCRIPTS | grep -q '/'; then
1986      # backwards compatibility: if no path is given get scripts from scripts/
1987      SCRIPTS="scripts/$SCRIPTS"
1988    fi
1989    if [ "$DCSMP" = "/mnt/grmlcfg" ]; then
1990      # we are executing from a GRMLCFG labeled fs
1991      # kick everything we have done before and start over
1992      SCRIPTS="$(cd ${DCSDIR}; /bin/ls -1d [Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1993    fi
1994    if [ -n "$SCRIPTS" ]; then
1995      SCRIPTS="${DCSDIR}/$SCRIPTS"
1996      if [ "$DCSMP" = "/mnt/grmlcfg" ]; then
1997        einfo "Trying to execute ${SCRIPTS}"
1998        sh -c $SCRIPTS
1999      elif [ -d "$SCRIPTS" ]; then
2000        einfo "Bootparameter scripts found. Trying to execute from directory ${SCRIPTS}:"
2001        run-parts $SCRIPTS
2002      else
2003        einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
2004        sh -c $SCRIPTS
2005      fi
2006    fi
2007 fi
2008 }
2009
2010 config_config(){
2011 if checkbootparam 'config' || [ "$DCSMP" = "/mnt/grmlcfg" ]; then
2012   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
2013   if [ -z "$CONFIG" ]; then
2014     CONFIG="$(cd ${DCSDIR}; ls -1d [Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
2015   fi
2016   if [ -n "$CONFIG" ]; then
2017     if [ -d "${DCSDIR}/${CONFIG}" ] ; then
2018       einfo "Taking configuration from directory ${DCSDIR}/${CONFIG}"
2019
2020       cp -a ${DCSDIR}/${CONFIG}/* /
2021     elif [ -f "${DCSDIR}/${CONFIG}" ]; then
2022       einfo "Extracting configuration from file ${DCSDIR}/${CONFIG}"
2023
2024       cd /
2025       unp ${DCSDIR}/${CONFIG} $EXTRACTOPTIONS ; eend $?
2026     else
2027       ewarn "Sorry, could not find configuration file or directory ${DCSDIR}/${FILENAME}." ; eend 1
2028     fi
2029   fi
2030 fi
2031 # umount $DCSMP if it was mounted by finddcsdir
2032 # this doesn't really belong here
2033 grep -q '$DCSMP' /proc/mounts && umount $DCSMP
2034 }
2035 # }}}
2036
2037 # {{{ mypath
2038 config_mypath(){
2039 if checkbootparam 'mypath' ; then
2040    MY_PATH="$(getbootparam 'mypath' 2>>$DEBUG)"
2041    einfo "Bootparameter mypath found, adding ${MY_PATH} to /etc/grml/my_path"
2042    touch /etc/grml/my_path
2043    chmod 644 /etc/grml/my_path
2044    # make sure the directories exist:
2045    eindent
2046    for i in $(echo $MY_PATH | sed 's/:/\n/g') ; do
2047        if ! [ -d "$i" ] ; then
2048           einfo "Creating directory $i"
2049           mkdir -p "$i" ; eend $?
2050        fi
2051    done
2052    grep -q "${MY_PATH}" /etc/grml/my_path || echo "${MY_PATH}" >> /etc/grml/my_path ; eend $?
2053    eoutdent
2054 fi
2055 }
2056 # }}}
2057
2058 # {{{ distcc
2059 config_distcc(){
2060 if checkbootparam 'distcc' ; then
2061  OPTIONS="$(getbootparam 'distcc' 2>>$DEBUG)"
2062  if [ -n "$OPTIONS" ]; then
2063     NET=""
2064     INTERFACE=""
2065     if [ -n "$OPTIONS" ]; then
2066       NET="${OPTIONS%%,*}"
2067       R="${OPTIONS#*,}"
2068       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2069         OPTIONS="$R"
2070         INTERFACE="${OPTIONS%%,*}"
2071         R="${OPTIONS#*,}"
2072       fi
2073     fi
2074  fi
2075  CONFIG=/etc/default/distcc
2076  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
2077  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
2078
2079  if [ -n "$INTERFACE" ] ; then
2080    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
2081
2082    counter=10
2083    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
2084      counter=$(( counter-1 ))
2085      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
2086      sleep 3
2087      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
2088    done
2089  fi
2090
2091  if [ -n "$IP" ] ; then
2092    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
2093
2094    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
2095    eindent
2096     id distccd >/dev/null 2>&1 || \
2097     (
2098       einfo "Creating distcc user" ; \
2099       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
2100     )
2101
2102     einfo "Starting distcc for network ${NET}, listening on ${IP}."
2103    /etc/init.d/distcc start >/dev/null ; eend $?
2104    eoutdent
2105  else
2106    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
2107  fi
2108 fi
2109
2110 if checkbootparam 'gcc'; then
2111  GCC="$(getbootparam 'gcc' 2>>$DEBUG)"
2112  eindent
2113  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
2114  eoutdent
2115  rm -f /usr/bin/gcc
2116  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
2117 fi
2118
2119 if checkbootparam 'gpp'; then
2120  GPP="$(getbootparam 'gpp' 2>>$DEBUG)"
2121  eindent
2122   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
2123   if [ -x /usr/bin/g++-${GPP} ] ; then
2124      rm -f /usr/bin/g++
2125      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
2126   fi
2127   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
2128   if [ -x /usr/bin/cpp-${GPP} ] ; then
2129      rm -f /usr/bin/cpp
2130      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
2131   fi
2132  eoutdent
2133 fi
2134
2135 }
2136 # }}}
2137
2138 # {{{ load modules
2139 # Notice: use it only on live-cd system, if running from harddisk please
2140 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
2141 # in /etc/runlevel.conf
2142 config_modules(){
2143 MODULES_FILE=/etc/grml/modules
2144 if checkbootparam 'nomodules' ; then
2145   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
2146 elif [ -z "$INSTALLED" ]; then
2147  if [ -r $MODULES_FILE ] ; then
2148   einfo "Loading modules specified in ${MODULES_FILE}:"
2149   eindent
2150   grep '^[^#]' $MODULES_FILE | \
2151   while read module args; do
2152     [ "$module" ] || continue
2153       einfo "${module}"
2154       modprobe $module $args ; eend $?
2155   done
2156   eoutdent
2157  else
2158   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
2159  fi
2160 fi
2161 }
2162 # }}}
2163
2164 # {{{ 915resolution
2165 config_915resolution(){
2166 if checkbootparam '915resolution' ; then
2167  OPTIONS="$(getbootparam '915resolution' 2>>$DEBUG)"
2168   if [ -x /usr/sbin/915resolution ]; then
2169     CMD=915resolution
2170     MODE=""
2171     XRESO=""
2172     YRESO=""
2173     if [ -n "$OPTIONS" ]; then
2174       # Extra options
2175       MODE="${OPTIONS%%,*}"
2176       R="${OPTIONS#*,}"
2177       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2178         OPTIONS="$R"
2179         XRESO="${OPTIONS%%,*}"
2180         R="${OPTIONS#*,}"
2181         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2182           OPTIONS="$R"
2183           YRESO="${OPTIONS%%,*}"
2184           R="${OPTIONS#*,}"
2185         fi
2186       fi
2187     fi
2188     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
2189     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
2190     eend 0
2191   fi
2192 fi
2193 }
2194 # }}}
2195
2196 # {{{ SW-RAID
2197 config_swraid(){
2198   [ -n "$INSTALLED" ] && return 0
2199
2200   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
2201   if checkbootparam 'noraid'   || checkbootparam 'noswraid' || \
2202      checkbootparam 'forensic' || checkbootparam 'raid=noautodetect' ; then
2203      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
2204   else
2205     if ! [ -x /sbin/mdadm ] ; then
2206        eerror "mdadm not available, can not execute it." ; eend 1
2207     else
2208
2209        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2210        # find out whether we have a valid configuration file already
2211        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2212           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
2213           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
2214           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
2215         else
2216           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
2217        fi
2218
2219        if ! checkbootparam 'swraid' ; then
2220           eindent
2221           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
2222           eoutdent
2223        else
2224           einfo "Bootoption swraid found. Searching for software RAID arrays:"
2225           eindent
2226            IFSOLD=${IFS:-}
2227            IFS='
2228 '
2229            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
2230                case $line in
2231                  *'No arrays found'*)
2232                    ewarn "$line" ; eend 0
2233                    ;;
2234                  *)
2235                    einfo "$line" ; eend 0
2236                    ;;
2237                esac
2238            done
2239            IFS=$IFSOLD
2240          eoutdent
2241
2242          if [ -r /proc/mdstat ] ; then
2243             eindent
2244             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
2245             if [ -z "$MDSTAT" ] ; then
2246                ewarn "No active arrays found" ; eend 0
2247             else
2248                IFSOLD=${IFS:-}
2249                IFS='
2250 '
2251                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
2252                    einfo "active arrays: $line" ; eend 0
2253                done
2254                IFS=$IFSOLD
2255             fi
2256             eoutdent
2257          fi # /proc/mdstat
2258        fi # bootoption swraid
2259
2260      fi # is /sbin/mdadm executable?
2261   fi # check for bootoptions
2262 }
2263 # }}}
2264
2265 # {{{ dmraid
2266 config_dmraid(){
2267   [ -n "$INSTALLED" ] && return 0
2268
2269   if checkbootparam 'nodmraid' ; then
2270     ewarn "Skipping dmraid code as requested on boot commandline." ; eend 0
2271     return 0
2272   fi
2273
2274   if ! [ -x /sbin/dmraid ] ; then
2275     eerror "dmraid not available, can not execute it." ; eend 1
2276     return
2277   fi
2278
2279   dmraid_wrapper() {
2280     # usage: dmraid_wrapper <dmraid_option>
2281     [ -n "$1" ] || return 1
2282
2283     IFSOLD=${IFS:-}
2284     IFS='
2285 '
2286     eindent
2287
2288     for line in $(dmraid $1 ; echo errcode:$?); do
2289       case $line in
2290         *'no block devices found'*)
2291           einfo "No block devices found" ; eend 0
2292           break
2293           ;;
2294         *'no raid disks'*)
2295           einfo "No active dmraid devices found" ; eend 0
2296           break
2297           ;;
2298         errcode:0)
2299           eend 0;
2300           ;;
2301         errcode:1)
2302           eend 1
2303           ;;
2304         *)
2305           einfo "$line"
2306           ;;
2307       esac
2308     done
2309
2310     eoutdent
2311     IFS=$IFSOLD
2312   }
2313
2314   if checkbootparam 'dmraid' ; then
2315     local ACTION="$(getbootparam 'dmraid' 2>>$DEBUG)"
2316     if [ "$ACTION" = "off" ] ; then
2317       # Deactivates all active software RAID sets:
2318       einfo "Deactivating present dmraid sets (as requested via dmraid=off):"
2319       dmraid_wrapper -an
2320     else
2321       # Activate all software RAID sets discovered:
2322       einfo "Activating present dmraid sets (as requested via dmraid):"
2323       dmraid_wrapper -ay
2324     fi
2325
2326     return
2327   fi
2328
2329   # by default (no special bootoptions) discover all software RAID devices:
2330   einfo "Searching for any present dmraid sets:"
2331   dmraid_wrapper -r
2332 }
2333 # }}}
2334
2335 # {{{ LVM (Logical Volumes)
2336 config_lvm(){
2337   [ -n "$INSTALLED" ] && return 0
2338
2339   if checkbootparam 'nolvm' ; then
2340      ewarn "Skipping LVM code as requested on boot commandline." ; eend 0
2341   else
2342     # Debian etch provides /etc/init.d/lvm only, newer suites provide /etc/init.d/lvm2
2343     if ! [ -x /sbin/lvm -a -x /sbin/lvdisplay ] || ! [ -x /etc/init.d/lvm2 -o -x /etc/init.d/lvm ] ; then
2344        eerror "LVM not available, can not execute it." ; eend 1
2345     else
2346        if lvdisplay 2>&1 | grep -v 'No volume groups found' >/dev/null 2>&1 ; then
2347           einfo "You seem to have logical volumes (LVM) on your system."
2348           eindent
2349           einfo "Just run 'Start lvm2' to activate them or boot using 'lvm' as bootoption for autostart."
2350           eend 0
2351           if checkbootparam 'lvm' ; then
2352              einfo "Bootoption LVM found. Searching for logical volumes:"
2353              /etc/init.d/lvm2 start ; eend $?
2354           fi
2355           eoutdent
2356        fi
2357     fi # check for lvm binary
2358   fi # check for bootoption nolvm
2359 }
2360 # }}}
2361
2362 # {{{ debnet: setup network based on an existing one found on a partition
2363 config_debnet(){
2364 if checkbootparam 'debnet' ; then
2365  iszsh && setopt localoptions shwordsplit
2366  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
2367  DEVICES="$DEVICES $(ls /dev/mapper/*)"
2368  FOUND_DEBNET=""
2369
2370  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
2371  eindent
2372  if ! mount | grep '/mnt ' >/dev/null 2>&1 ; then
2373     for i in $DEVICES; do
2374      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
2375          einfo "Scanning on $i"
2376        if [ -f /mnt/etc/network/interfaces ]; then
2377          einfo "/etc/network/interfaces found on ${i}" ; eend 0
2378          FOUND_DEBNET="$i"
2379          break
2380        fi
2381        umount /mnt
2382      fi
2383     done
2384
2385    if [ -n "$FOUND_DEBNET" ]; then
2386      einfo "Stopping network."
2387        pump -k >/dev/null 2>&1
2388        /etc/init.d/networking stop >/dev/null 2>&1 ; eend $?
2389      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
2390        rm -rf /etc/network/run
2391        cp -a /mnt/etc/network /etc
2392        rm -rf /etc/network/run
2393        mkdir /etc/network/run
2394        umount /mnt ; eend $?
2395      einfo "Starting network."
2396        invoke-rc.d networking start ; eend $?
2397    else
2398      eerror "/etc/network/interfaces not found." ; eend 1
2399    fi
2400    eoutdent
2401  else
2402   eerror "Error: /mnt already mounted." ; eend 1
2403  fi
2404 fi
2405 }
2406 # }}}
2407
2408 # {{{ disable console blanking
2409 config_blanking(){
2410 if checkbootparam 'noblank' ; then
2411   einfo "Bootoption noblank found. Disabling monitor blanking."
2412   setterm -blank 0 ; eend $?
2413 fi
2414 }
2415 # }}}
2416
2417 # {{{ tohd= bootoption
2418 config_tohd()
2419 {
2420   if checkbootparam 'tohd' ; then
2421      local TARGET="$(getbootparam 'tohd' 2>>$DEBUG)"
2422      if [ -z "$TARGET" ] ; then
2423         eerror "Error: tohd specified without any partition, can not continue." ; eend 1
2424         eerror "Please use something like tohd=/dev/sda9." ; eend 1
2425         return 1
2426      fi
2427
2428      if ! [ -b "$TARGET" ] ; then
2429         eerror "Error: $TARGET is not a valid block device, sorry." ; eend 1
2430         return 1
2431      fi
2432
2433      if grep -q $TARGET /proc/mounts ; then
2434         eerror "$TARGET already mounted, skipping execution of tohd therefore."
2435         eend 1
2436         return 1
2437      fi
2438
2439      local MOUNTDIR=$(mktemp -d)
2440
2441      if mount -o rw "$TARGET" "$MOUNTDIR" ; then
2442         einfo "Copyring live system to $TARGET - this might take a while"
2443         rsync -a --progress /live/image/live $MOUNTDIR
2444         sync
2445         umount "$MOUNTDIR"
2446         eend $?
2447         einfo "Booting with \"grml bootfrom=$TARGET\" should work now." ; eend 0
2448      else
2449         eerror "Error when trying to mount $TARGET, sorry."; eend 1
2450         return 1
2451      fi
2452
2453      rmdir "$MOUNTDIR"
2454   fi
2455 }
2456 # }}}
2457
2458 # {{{ grml2hd: automatic installation
2459 config_grml2hd(){
2460
2461 if checkbootparam "BOOT_IMAGE=grml2hd" ; then
2462
2463 if checkbootparam 'user' ; then
2464    NEWUSER=''
2465    NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2466    sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2467 fi
2468
2469 if checkbootparam 'filesystem' ; then
2470    FILESYSTEM=''
2471    FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2472    sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2473 fi
2474
2475 if checkbootparam 'partition' ; then
2476    PARTITION=''
2477    PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2478    # notice: the following checks whether the given partition is available, if not the skip
2479    # execution of grml2hd as it might result in data loss...
2480    if [ -r $PARTITION ] ; then
2481       sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2482    else
2483       ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2484    fi
2485 fi
2486
2487 if checkbootparam 'mbr' ; then
2488    BOOT_PARTITION=''
2489    BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2490    sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2491 fi
2492
2493 cat>|/usr/bin/grml2hd_noninteractive<<EOF
2494 #!/bin/sh
2495 GRML2HD_NONINTERACTIVE='yes' grml2hd
2496 EOF
2497
2498 chmod 755 /usr/bin/grml2hd_noninteractive
2499 einfo "Bootoption grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2500 if [ -z "$GRML2HD_FAIL" ] ; then
2501    screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2502 else
2503    ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2504 fi
2505
2506 fi # if checkbootparam "BOOT_IMAGE=grml2hd ...
2507 }
2508 # }}}
2509
2510 # {{{ debootstrap: automatic installation
2511 config_debootstrap(){
2512
2513 if checkbootparam "BOOT_IMAGE=debian2hd" ; then
2514
2515 einfo "Bootoption debian2hd found. Setting up environment for automatic installation via grml-debootstrap." ; eend 0
2516
2517 if ! [ -x /usr/sbin/grml-debootstrap ] ; then
2518    eindent
2519    eerror "Bootoption debian2hd found, but grml-debootstrap is not available." ; eend 1
2520    eoutdent
2521    exit 1
2522 fi
2523
2524 if checkbootparam 'target' ; then
2525   TARGET=''
2526   TARGET="$(getbootparam 'target' 2>>$DEBUG)"
2527   # notice: the following checks whether the given partition is available, if not the skip
2528   # execution of grml-debootstrap as it might result in data loss...
2529   if ! [ -r "$TARGET" ] ; then
2530      eerror "Target $TARGET does not exist. Skipping execution of grml-debootstrap therefore." ; eend 1
2531   fi
2532 else
2533   eindent
2534   eerror "No bootoption named target found, can not continue execution of grml-debootstrap." ; eend 1
2535   eoutdent
2536   exit 1
2537 fi
2538
2539 if checkbootparam 'grub' ; then
2540   GRUB=''
2541   GRUB="$(getbootparam 'grub' 2>>$DEBUG)"
2542 fi
2543
2544 if checkbootparam 'groot' ; then
2545   GROOT=''
2546   GROOT="$(getbootparam 'groot' 2>>$DEBUG)"
2547 fi
2548
2549 if checkbootparam 'release' ; then
2550   RELEASE=''
2551   RELEASE="$(getbootparam 'release' 2>>$DEBUG)"
2552 fi
2553
2554 if checkbootparam 'mirror' ; then
2555   MIRROR=''
2556   MIRROR="$(getbootparam 'mirror' 2>>$DEBUG)"
2557 fi
2558
2559 if checkbootparam 'boot_append' ; then
2560   BOOT_APPEND=''
2561   BOOT_APPEND="$(getbootparam 'boot_append' 2>>$DEBUG)"
2562 fi
2563
2564 if checkbootparam 'password' ; then
2565   PASSWORD=''
2566   PASSWORD="$(getbootparam 'password' 2>>$DEBUG)"
2567 fi
2568
2569 # now check which options are available
2570 if [ -n "TARGET" ] ; then
2571    TARGETCMD="--target $TARGET"
2572 else
2573    TARGETCMD=''
2574    eindent
2575    eerror "Target not set via bootoption. Skipping execution of grml-debootstrap therefore."; eend 1
2576    eoutdent
2577    exit 1
2578 fi
2579 [ -n "$GRUB" ]     && GRUBCMD="--grub $GRUB"               || GRUBCMD=''
2580 [ -n "$GROOT" ]    && GROOTCMD="--groot $GROOT"            || GROOTCMD=''
2581 [ -n "$RELEASE" ]  && RELEASECMD="--release $RELEASE"      || RELEASECMD=''
2582 [ -n "$MIRROR" ]   && MIRRORCMD="--mirror $MIRROR"         || MIRRORCMD=''
2583 [ -n "$PASSWORD" ] && PASSWORDCMD="--password $PASSWORD"   || PASSWORDCMD=''
2584 [ -n "$BOOT_APPEND" ] && BOOT_APPEND="--boot_append $BOOT_APPEND" || BOOT_APPEND=''
2585
2586 # and finally write script and execute it
2587 cat>|/usr/bin/grml-debootstrap_noninteractive<<EOF
2588 #!/bin/sh
2589 AUTOINSTALL='yes' grml-debootstrap $TARGETCMD $GRUBCMD $GROOTCMD $RELEASECMD $MIRRORCMD $PASSWORDCMD $BOOT_APPEND
2590 EOF
2591
2592 chmod 750  /usr/bin/grml-debootstrap_noninteractive
2593
2594 screen /usr/bin/grml-debootstrap_noninteractive
2595 einfo "Invoking a shell, just exit to continue booting..."
2596 /bin/zsh
2597
2598 fi # checkbootparam "BOOT_IMAGE=debian2hd
2599 }
2600 # }}}
2601
2602 # {{{ Support customization
2603 config_distri(){
2604 if checkbootparam 'distri'; then
2605   DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
2606   if [ -r "${LIVECD_PATH}"/desktop/"$DISTRI".jpg ] ; then
2607      [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file ${LIVECD_PATH}/desktop/${DISTRI} present" && eend 0
2608      # make sure the desktop.jpg file is not a symlink, so copying does not file then
2609      [ -L /usr/share/grml/desktop.jpg ] && rm /usr/share/grml/desktop.jpg
2610      cp "${LIVECD_PATH}"/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
2611   fi
2612 fi
2613 }
2614 # }}}
2615
2616 ### {{{ backwards compatible stuff
2617 config_environment(){
2618   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2619 }
2620 config_keyboard(){
2621   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2622 }
2623 # }}}
2624
2625 ## END OF FILE #################################################################
2626 # vim:foldmethod=marker expandtab ai ft=zsh shiftwidth=3